/*
to compile the sources:
on DOS prompt: cl65 -v -O -C hanoi.cfg hanoi_final.c hanoi_asm.s -o hanoi.prg
to run: sys 16384
exomizer sfx $4000 hanoi.prg -o hanoi-exo.prg -n
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "hanoi.h"

//#include <joystick.h>
//#include <PEEKPOKE.h>

#define uchar unsigned char
#define uint unsigned int
#define slint long int
#define ulint unsigned long int
#define POKE(addr,val) (*(unsigned char*) (addr) = (val))
#define PEEK(addr) (*(unsigned char*) (addr))
#define VI 0xd000
#define SI 0xd400
#define MV 0x0400
#define MC 0xd800
#define SPRITE 0x3e00//8192 

void TOH (int n, char src, char spare, char dest);
uchar DecimalToBCD (char decimalByte);
uchar BCDToDecimal(char bcdByte);
void set_TOD(void);
void read_TOD(void);
void Delay(unsigned int count);
void move(void);
void LoHi( int integer);

uint ssel[8]={0xd000,0xd002,0xd004,0xd006,0xd008,0xd00a,0xd00c,0xd00e};
uchar scolor[8]={0,1,4,5,6,7,9,10};
uchar snum[8]={0,0,7,15,31,63,127,255}; 
uchar salt[8]={203,194,185,176,167,158,149,140};
uchar sy[8];
uchar col[3]={72,160,247};
int c[3]={0,0,0};

char p[3][8];

uchar string[38];


uint minmoves=1;
uint n,i,j,moves=0;
uint sadd=SPRITE;  //,2112,2176,2240,2304,2368,2432,2496};
char ds,top,sel,f,t,tmp,win,to,from,X,Y;
//char a,b,c; 

char time[13];
uint hour=0xdc0b;        // todhour
uint min=0xdc0a;         // todmin
uint sec=0xdc09;         //todsec
uint ten=0xdc08;         // todten
//   uint screen = 1238;
uint h,h1,m,s,te,count,del; 
uchar XSize, YSize;
unsigned char Lo, Hi;
unsigned int address;


int main()
{
		
	init_msx(0); 						//Init SID
    title_irq();						//Play 



//for (i=0;i<=24;i++) 
//POKE((SI+i),0);   //reset SID

//POKE ((VI+32),0);  //border color
//POKE ((VI+33),0);  //screeen color

//cprintf ("attendi un attimoves per favore\r\n");
//cprintf ("se vuoi arrenderti prima di terminare il gioco premi \"f\"\r\n");


for (i=0;i<=7;i++)					
POKE ((2040+i),(SPRITE/64)+i);		//set sprite pointers

POKE ((VI+21),0); //sprite enable
POKE ((VI+16),0);  //hight X bit
POKE ((VI+23),0);  //sprite expand Y
POKE ((VI+29),255);  //sprite expand X
POKE ((VI+0x18),0x18);  //sprite expand X

clrscr();//clear screen
//textcolor(1);//set color of text
bordercolor (0);
bgcolor (0);
cursor(0);

memcpy((void*)(MV),(void*)&TITLE_MAP,1000);
address=&TITLE_ATTRIBUTES;
LoHi(address);
makecolour(Hi,Lo);

num|=4;
while(num&4)read_joy();
toggle=1;


memcpy((void*)(0x2000),(void*)&CHARSET_GAME,2192);

//clrscr();//clear screen
memcpy((void*)(MV),(void*)&HANOI_MAP,1000-40);
address=&HANOI_ATTRIBUTES;
LoHi(address);
makecolour(Hi,Lo);


while(1){
win=sel=ds=moves=0;
minmoves=1;	

POKE ((VI+21),0); //sprite enable
for(i=0;i<=7;i++){   
POKE ((VI+1+2*i),salt[i]);   	//set sprite y pos 
POKE ((VI+2*i),col[0]);  			// set X sprite position
POKE ((VI+38+i),scolor[i]);  	//set sprite color
sy[i]=0;
num=5;
}

for(j=0;j<3;j++){
for(i=0;i<=7;i++){
p[j][i]=0;}
c[j]=0;
}

//clrscr();//clear screen
//screensize (&X, &Y);
textcolor(7);

//sprintf(string,"how many disks? [3-8]");
//gotoxy ((XSize-strlen(time))/2,1); 
//textcolor(7);
//cprintf ("%s",string);


gotoxy(1,1);
cprintf ("        how many disks? [3-8]         ");
gotoxy(1,2);
cprintf ("                                      ");
gotoxy(1,3);
cprintf ("                                      ");
//cprintf (" In runtime game:[R]estart,[Q]uit");
//gotoxy(1,5);
//chline (X - 2);
//gotoxy(1,22);
//chline (X - 2);

//cvlinexy(8,11,10);
//cvlinexy(20,11,10);
//cvlinexy(31,11,10);
//gotoxy(7,23);
//cprintf(" #1         #2         #3");



do{
n=cgetc();}
while(n<51||n>56);
n-=48;
c[0]=n;
top=n;

--n;
for (i=0;i<=n;i++) {p[0][i]=(i+1);   //initialize table
minmoves*=2;}
textcolor(4);
gotoxy(1,2);
cprintf("        minimun moves to win=%u",minmoves-1);
POKE ((VI+21),snum[n]);

textcolor(2);
gotoxy(1,1);
cprintf("   [p]lay, [s]low/[f]ast solving      ");
while((sel!='p')&&(sel!='s')&&(sel!='f'))sel=cgetc(); 
tmp=sel;
set_TOD();
textcolor(1);
cputsxy(7,23,">#1<");

while(win==0){
if(sel=='p'){
gotoxy(1,1);
cprintf ("          from which stack?           "); 
do{
//do{f=cgetc();}while(f<49||f>51);
//f-=49;
move();
f=num-1;

while(p[f][0]==0){

gotoxy(1,1);
cprintf("    empty stack, from which stack?     ");
//do{f=cgetc();}while(f<49||f>51);
//f-=49;
move();
f=num-1;
}

gotoxy(1,1);
cprintf("           to which stack?            ");
//do{t=cgetc();}while(t<49||t>51);
//t-=49;
move();
t=num-1;

while(f==t){
	gotoxy(1,1);
	cprintf("       same stack, which stack?       ");
//	do{t=cgetc();}while(t<49||t>51);
//			t-=49;
move();
t=num-1;
}

from=p[f][c[f]-1];
to=p[t][c[t]-1];

if (from<to){
	gotoxy(1,1);
	cprintf("    bigger disk, from which stack?    ");}
	
	
}while(from<to);
}

else{
	gotoxy(7,23);
    cprintf(" #1         #2         #3 ");
	TOH((n+1),'0','1','2');
    if(top==p[1][n]||top==p[2][n]){
	read_TOD();
	textcolor(7);
	gotoxy(1,3);
    cprintf(" finished in %s moves:%d",time,moves);
	textcolor(3);
	gotoxy(1,1);
	cprintf("        press fire to continue        ");

//	while(cgetc()==0);
	num|=4;
    while(num&4)read_joy();
	win=1;
	moves=0;
	continue;
	}
	}

//if ((c[f]-1)==0)c[f]=c[f]-1;
ds=p[f][c[f]-1];

p[t][c[t]]=ds;
p[f][c[f]-1]=0;
c[f]=c[f]-1;
c[t]=c[t]+1;
moves++;

gotoxy(1,3);
cprintf("   c[0]=%d, c[1]=%d, c[2]=%d, moves=%d",c[0],c[1],c[2],moves);

//cprintf("p[f][c[f]-1]=%d\r\n",p[f][c[f]-1]);
//cprintf("p[t][c[t]-1]=%d\r\n",p[t][c[t]-1]);



for(i=salt[ds-1];i>99;i--){
	Delay(1);
	POKE((ssel[ds-1]+1),i);}

if (col[f]<col[t]){
		for(i=col[f];i<=col[t];i++){
		Delay(1);
		POKE(ssel[ds-1],i);}
}
	else{ 
	
	for(i=col[f];i>=col[t];i--){
	Delay(1);
	POKE(ssel[ds-1],i);}
	}
sy[ds-1]=salt[c[t]-1];
for(i=100;i<=sy[ds-1];i++){
	Delay(1);
	POKE((ssel[ds-1]+1),i);}



if(top==p[1][n]||top==p[2][n]){
	read_TOD();
	textcolor(7);
	gotoxy(1,1);
    cprintf("  finished! %s moves:%d ",time,moves);
	textcolor(3);
	gotoxy(1,3);
	cprintf("        press fire to continue        ");
	num|=4;
    while(num&4)read_joy();
//	while(cgetc()==0);
	win=1;}
}
}
return 0;
}
void TOH (int n, char src, char spare, char dest)
{
if (n==1){
if (tmp=='s'){
	del=1;
textcolor(14);
gotoxy(1,1);
cprintf("       press fire for next move       ");	
textcolor(1);
//while(cgetc()==0);
num|=4;
while(num&4)read_joy();
}

else del=0;   

f=src-48,t=dest-48;
ds=p[f][c[f]-1];
p[t][c[t]]=ds;
p[f][c[f]-1]=0;
c[f]=c[f]-1;
c[t]=c[t]+1;
moves++;


gotoxy(1,3);
cprintf("   c[0]=%d, c[1]=%d, c[2]=%d, moves=%d",c[0],c[1],c[2],moves);

//cprintf("p[f][c[f]-1]=%d\r\n",p[f][c[f]-1]);
//cprintf("p[t][c[t]-1]=%d\r\n",p[t][c[t]-1]);

for(i=salt[ds-1];i>99;i--){
	Delay(del);
	POKE((ssel[ds-1]+1),i);}

if (col[f]<col[t]){
		for(i=col[f];i<=col[t];i++){
		Delay(del);
		POKE(ssel[ds-1],i);}
}
	else{ 
	
	for(i=col[f];i>=col[t];i--){
	Delay(del);
	POKE(ssel[ds-1],i);}
	}
sy[ds-1]=salt[c[t]-1];
for(i=100;i<=sy[ds-1];i++){
	Delay(del);
	POKE((ssel[ds-1]+1),i);}
}
else
{
TOH(n-1, src, dest, spare) ;
TOH(1, src, spare, dest);
TOH(n-1, spare, src, dest);
}
}

char BCDToDecimal (char bcdByte)
{
  return (((bcdByte & 0xF0) >> 4) * 10) + (bcdByte & 0x0F);
}

char DecimalToBCD (char decimalByte)
{
  return (((decimalByte / 10) << 4) | (decimalByte % 10));
}

 void set_TOD(void){
h=h1=m=s=te=0;
POKE(0xDC0E,(PEEK(0xDC0E)|0x80));  //set TOD
POKE(hour,h);
POKE(min,m);
POKE(sec,s);
POKE(ten,te);
}
 void read_TOD(void){
   h=BCDToDecimal(h1);
   m=BCDToDecimal (PEEK(min));
   s=BCDToDecimal (PEEK(sec));
   te=BCDToDecimal (PEEK(ten));
sprintf(time,"%02d min %02d sec",m,s);
}

void move(void){
	num|=4;
while(num&4){
	read_joy();
	switch(num){
		
		case 5: 
				cputsxy(7,23,">#1<");
				cputsxy(18,23," #2 ");
				cputsxy(29,23," #3 ");
				break;
		case 6: 
				cputsxy(7,23," #1 ");
				cputsxy(18,23,">#2<");
				cputsxy(29,23," #3 ");
				break;
		case 7: 
				cputsxy(7,23," #1 ");
				cputsxy(18,23," #2 ");
				cputsxy(29,23,">#3<");
		break;	
		}
}
}

void Delay(unsigned int count)
{ 
unsigned int i; 
while(count)
{
i = 10; //115;
while(i>0) i--;
count--;
}
}

  
 
 void LoHi( int integer)
 {
    Lo=integer&(0xff);
    Hi = (integer>>8) & 0xff;
 }